// Copyright 2016 Orus.io. All rights reserved.

package sql

import (
	"testing"

	"bitbucket.org/orus-io/xbus/storage"
	"bitbucket.org/orus-io/xbus/testutils"
	"bitbucket.org/orus-io/xbus/testutils/sqldb"
	storagetest "bitbucket.org/orus-io/xbus/testutils/storage"
)

func envelopeStorageFactory(tb testing.TB) (storage.EnvelopeStorage, func()) {
	testDB := sqldb.GetTestDB(tb)
	if testDB == nil {
		return nil, nil
	}
	m, db := testDB.GetModelDB(1)

	return NewEnvelopeStorage(m, db, testutils.GetTestLogger(tb)), func() {
		db.Close()
		testDB.Close()
	}
}

func TestEnvelopeStorage(t *testing.T) {
	storagetest.EnvelopeStorageTests(t, envelopeStorageFactory, false)
}

func BenchmarkEnvelopeStorage(b *testing.B) {
	storagetest.EnvelopeStorageBench(b, envelopeStorageFactory)
}
