package api

const (
	// ProcessStatePrefix is the prefix for process state apis
	ProcessStatePrefix = XbusAPIPrefix + "processstate."
)

// EmitterEnvelopeStateSubject returns the subject on which process events are sent
func EmitterEnvelopeStateSubject(emitter UUID, envelopeID UUID) string {
	subject := ProcessStatePrefix
	if emitter.IsZero() {
		subject += "*"
	} else {
		subject += emitter.String()
	}
	subject += ".envelope."
	if envelopeID.IsZero() {
		subject += "*"
	} else {
		subject += envelopeID.String()
	}
	return subject
}
